<?php

namespace App\Entity;

use App\Config\View;
use App\Repository\ProfileRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: ProfileRepository::class)]
class Profile
{
    //public static $VIEW = ['liste' => 0, 'vignette' => 1];


    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column(type: Types::INTEGER)]

    private ?int $id = null;


    #[ORM\OneToOne(targetEntity: User::class, inversedBy: "profile", cascade: ["persist", "remove"])]
    #[ORM\JoinColumn(nullable: false)]

    private ?User $user = null;


    #[ORM\Column(type: Types::INTEGER, enumType: View::class)]

    private ?View $view = null;

    public function __construct()
    {
        $this->setView(View::VIGNETTE);
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getUser(): ?User
    {
        return $this->user;
    }

    public function setUser(?User $user): self
    {
        $this->user = $user;

        return $this;
    }

    public function getView(): ?View
    {
        return $this->view;
    }

    public function setView(?View $view): self
    {
        $this->view = $view;

        return $this;
    }
}
